/**
 * 
 */
package net.bigeon.gclc.swt;

import java.io.IOException;

import org.eclipse.swt.widgets.Text;

import net.bigeon.gclc.utils.PipedConsoleInput;

/** @author Emmanuel Bigeon */
public final class ConsoleInputManager implements ConsoleDelayIO {

    private final Text        text;
    private PipedConsoleInput input;

    /** @param text the text */
    public ConsoleInputManager(final Text text) {
        super();
        this.text = text;
    }

    /** @param string the text */
    @Override
    public void setInput(final String string) {
        text.setText(string);
        text.setSelection(string.length());
    }

    /* (non-Javadoc)
     * @see net.bigeon.gclc.swt.ConsoleDelayIO#getInput() */
    @Override
    public String getInput() {
        return text.getText();
    }

    @Override
    public void validateInput() throws IOException {
        input.type(text.getText());
    }

    /** Set the input to control
     * 
     * @param input the input */
    public void setManager(final PipedConsoleInput input) {
        this.input = input;
    }

    /** @return the text */
    public Text getText() {
        return text;
    }
}
